/****************************************************************************
CToolsLib - Use-Case Library Trace Example
File: UCLib_DSPTrace.c

This example demonstrates how to capture PC and Timing trace with
the CTOOLS use case library and then use CPU/EDMA to drain the
contents of the Embedded Trace Buffer (ETB)

For more details refer to ctools use case library Doxygen API reference

Copyright (c) 2009-2014 Texas Instruments Inc. (www.ti.com)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "ctools_uclib.h"
#include "c6x.h"

#ifdef UCLIB_ETB_EDMA

#if defined(C6670)
#include "DeviceSpecific_C6670.h"
#elif defined(C6657)
#include "DeviceSpecific_C6657.h"
#elif defined(C6678)
#include "DeviceSpecific_C6678.h"
#elif defined(TCI6614)
#include "DeviceSpecific_C6614.h"
#elif defined(_66AK2Gxx)
#include "DeviceSpecific_66AK2Gxx.h"
#elif defined(C66AK2Hxx) || defined(TCI6630K2L) || defined(C66AK2Exx)
#include "DeviceSpecific_C66AK2Hxx.h"
#endif

#endif

/*******************************************************************************
 *    INSTRUCTIONS FOR DECODING BINARY TRACE DATA GENERATED BY THIS EXAMPLE
 *******************************************************************************
 *  - C66x DSP PC trace is collected and stored in
 *    C:\temp\dsp_etbdata_core(n).bin
 *  - bin2tdf utility is required, located in:
 *    -> cd <CCS install dir>\ccs_base\emulation\analysis\bin
 *  - To convert binary trace data captured into TDF, use the following
 *     command line:
 *    -> bin2tdf -bin C:/temp/dsp_etbdata_core(n).bin -app <path to example.out> -procid 66x
 *       -sirev 1 -rcvr ETB -output C:/temp/dsp_etbdata_core(n).tdf
 *  - The dsp_etbdata_core(n).tdf file may be opened from the CCS menu Tools->
 *     Hardware Trace Analyzer->Open File...
 *  - For more details refer to: http://processors.wiki.ti.com/index.php/BIN2TDF
 *******************************************************************************
 ******************************************************************************/
#ifdef UCLIB_ETB_EDMA
#define N_APP_FUNCTION_RUNS 400
#else
#define N_APP_FUNCTION_RUNS 100
#endif

//Statistical profiling sampling period
#define SAMPLING_PERIOD 20000

/*******************************************************************************
 * FUNCTIONS AND PARAMETERS USED FOR EXAMPLE APPLICATION
 */
uint32_t globalCntr[10] = {0, };
uint32_t globalMarker = 0;

void endFunction()
{
   volatile int dummy1 =10, dummy2=0;

   dummy2 = dummy1 - 1;
    globalMarker = 10;

    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;
    dummy2--;
    globalCntr[dummy2]++;

    globalMarker = 20;
    return;
}

void startFunction()
{
   volatile int dummy1 =0, dummy2=0;
   dummy1++;

   dummy2 += dummy1 + 20;

    globalCntr[8]++;

    return;
}


void appFunction()
{
   volatile int dummy1 =100, dummy2=0;

   dummy2 = dummy1 - 1;

   while(dummy2 > 1)
   {
      dummy2--;
        if(dummy2 & 1)
        {
            endFunction();
        }
        if(dummy2 & 0x4)
        {
            startFunction();
        }
   }

}

void runFunction()
{
   volatile int dummy1 =0, dummy2=0;
   dummy1++;

   dummy2 += dummy1 + 20;
}

void doneFunction(void)
{
    volatile uint32_t temp;
}

void example_start_symb(void)
{
	asm (" nop ");
}

void example_stop_symb(void)
{
	asm (" nop ");
}

#define MAX_DSP_CORES 8

#pragma DATA_SECTION(etb_drain_mem, ".app_etb_drain_mem")
#define ETB_SIZE_BYTES 4096
#define ETB_EXTENDED_SIZE_BYTES    (ETB_SIZE_BYTES*4)

#ifdef UCLIB_ETB_EDMA
uint8_t etb_drain_mem[ETB_EXTENDED_SIZE_BYTES];
#else
uint8_t etb_drain_mem[ETB_SIZE_BYTES];
#endif

#define BYTE_SWAP32(n) \
	( ((((uint32_t) n) << 24) & 0xFF000000) |	\
	  ((((uint32_t) n) <<  8) & 0x00FF0000) |	\
	  ((((uint32_t) n) >>  8) & 0x0000FF00) |	\
	  ((((uint32_t) n) >> 24) & 0x000000FF) )

void main(void)
{
	ctools_Result ctools_ret = CTOOLS_SOK;
	uint32_t idx=0;
	uint32_t*   pBuffer = 0;

#if defined(STAT_PROF)

	char     core_fname[MAX_DSP_CORES][64]= {
			"C:\\temp\\statprof_etbdata_core0.bin",
			"C:\\temp\\statprof_etbdata_core1.bin",
			"C:\\temp\\statprof_etbdata_core2.bin",
			"C:\\temp\\statprof_etbdata_core3.bin",
			"C:\\temp\\statprof_etbdata_core4.bin",
			"C:\\temp\\statprof_etbdata_core5.bin",
			"C:\\temp\\statprof_etbdata_core6.bin",
			"C:\\temp\\statprof_etbdata_core7.bin"
	};

#else

	char     core_fname[MAX_DSP_CORES][64]= {
			"C:\\temp\\dsp_etbdata_core0.bin",
			"C:\\temp\\dsp_etbdata_core1.bin",
			"C:\\temp\\dsp_etbdata_core2.bin",
			"C:\\temp\\dsp_etbdata_core3.bin",
			"C:\\temp\\dsp_etbdata_core4.bin",
			"C:\\temp\\dsp_etbdata_core5.bin",
			"C:\\temp\\dsp_etbdata_core6.bin",
			"C:\\temp\\dsp_etbdata_core7.bin"
	};

#endif

#ifndef UCLIB_ETB_EDMA
	uint32_t size_out, wrap_flag;
	ctools_etb_config_t etb_config = {0};
	etb_config.etb_mode = eETB_TI_Mode;
#endif

    /* Initialize the ETB */
#ifdef UCLIB_ETB_EDMA

	/* Clear the drain memory */
	for (idx=0; idx<ETB_EXTENDED_SIZE_BYTES; idx++)
	{
		etb_drain_mem[idx] = 0xCC;
	}

	ctools_ret = UCLib_Config_EDMA_for_DSPETB((uint32_t)&etb_drain_mem, (ETB_EXTENDED_SIZE_BYTES/4), DNUM);

#else

	/* Clear the drain memory */
	for (idx=0; idx<ETB_SIZE_BYTES; idx++)
	{
		etb_drain_mem[idx] = 0xCC;
	}

	ctools_ret = ctools_etb_init(CTOOLS_DRAIN_ETB_CPU, &etb_config, CTOOLS_DSP_ETB);

#endif

	if (ctools_ret != CTOOLS_SOK)
	{
	    printf (" ETB initialization failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}

	/* Initialize the DSP trace
     * Please refer to the ctools use case library Doxygen API reference
     * Guide for the API usage */
	ctools_ret = ctools_dsptrace_init();
	if (ctools_ret != CTOOLS_SOK)
	{
	    printf (" DSP trace initialization failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}

#if !defined(STAT_PROF)

#ifdef UCLIB_ETB_EDMA
	/* Start the PC and Timing Trace capture at example_start_symb()
	 * and stop trace capture at example_stop_symb()
	 */
	ctools_ret = ctools_pct_setup(&example_start_symb, &example_stop_symb);
	if (ctools_ret != CTOOLS_SOK)
	{
	    printf (" PC trace setup failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}
#else
	/* Start the PC and Timing Trace capture from this point
	 * After completing this function, the core would be logging
	 * the PC and timing trace to the ETB buffer in a circular way
	 * on this core
	 */
	ctools_ret = ctools_pct_start_now();
	if (ctools_ret != CTOOLS_SOK)
	{
	    printf (" Start PC trace now failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}
#endif

#endif

    /* ******************************************************************************** */
    /* ******************************************************************************** */
    /* ********************************** APP CODE ************************************ */

#if defined(STAT_PROF)

	//start statistical profiling
	ctools_ret = ctools_stat_prof_start(SAMPLING_PERIOD);
	if (ctools_ret != CTOOLS_SOK)
	{
	    printf (" ctools_stat_prof_start failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}

#endif

	/* trigger the PC trace start in ETB when PC hits this function */
	example_start_symb();

    /***** Now the app runs and generates trace data ****/

    runFunction();

    for(idx = 0; idx < N_APP_FUNCTION_RUNS; idx++)
    {
    	appFunction();
    }

    doneFunction();

	/* Trigger the PC trace stop when PC hits this function*/
	example_stop_symb();

#if defined(STAT_PROF)

	//stop statistical profiling
	ctools_ret = ctools_stat_prof_end();
	if (ctools_ret != CTOOLS_SOK)
	{
	    printf (" ctools_stat_prof_end failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}

#endif

#ifdef UCLIB_ETB_EDMA
	ctools_edma_result_t pct_edma_res;

	/* This would copy extended ETB buffer as a linear buffer
	 * containing PC and timing traces to the memory provided here */
	ctools_ret = ctools_etb_edma_drain(&pct_edma_res, CTOOLS_DSP_ETB);

	if(ctools_ret == CTOOLS_SOK)
	{
		printf("EDMA ETB drain successful\n");

		if(pct_edma_res.isWrapped == 1)
		{
			printf("Buffer wrapped Start: Addr - 0x%08x and Available words - %d\n", pct_edma_res.startAddr, pct_edma_res.availableWords);
		}
		else
		{
			printf("Buffer NOT wrapped: Start Addr - 0x%08x and Available words - %d\n", pct_edma_res.startAddr, pct_edma_res.availableWords);
		}
	}
	else
	{
		printf("EDMA ETB drain failed %d\n", ctools_ret);
	}

#else

#if !defined(STAT_PROF)

	/*Trigger the PC trace stop when PC hits this function*/
    ctools_ret = ctools_pct_stop_now();
	if (ctools_ret != CTOOLS_SOK)
	{
	    printf (" Stop PC trace now failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}

#endif

	/* This would copy ETB hardware buffer as a linear buffer
	 * containing PC and timing traces to the memory provided here */
	ctools_ret = ctools_etb_cpu_drain(&etb_drain_mem, 4096, &size_out, &wrap_flag, CTOOLS_DSP_ETB);

	if(ctools_ret == CTOOLS_SOK)
	{
		printf("CPU ETB drain successful\n");

		if(wrap_flag == 1)
		{
			printf("Buffer wrapped and Available words - %d\n", size_out);
		}
		else
		{
			printf("Buffer NOT wrapped and Available words - %d\n", size_out);
		}
	}
	else
	{
		printf("CPU ETB drain failed %d\n", ctools_ret);
	}
#endif

#if !defined(STAT_PROF)

	/* Close the PCT */
	ctools_ret = ctools_pct_close ();

	if(ctools_ret == CTOOLS_SOK)
	{
		printf("PC trace close successful\n");
	}
	else
	{
		printf("PC trace close failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}

#endif

	/* Shutdown the dsp trace */
	ctools_ret = ctools_dsptrace_shutdown();
	if(ctools_ret == CTOOLS_SOK)
	{
		printf("DSP trace shutdown successful\n");
	}
	else
	{
		printf("DSP trace shutdown failed %d\n", ctools_ret);
		exit (EXIT_FAILURE);
	}

	/* Transport the ETB data captured */
	{
		/* this example uses JTAG debugger via CIO to transport data to host PC */
		/* An app can deploy any other transport mechanism to move the ETB buffer to the PC */
		FILE* fp = fopen(core_fname[DNUM], "wb");
		if(fp)
		{
			uint32_t sz = 0;
			uint32_t i = 1;
   			char *le = (char *) &i;
   			size_t fret;
   			uint32_t etbword;

#ifdef UCLIB_ETB_EDMA
   			uint32_t  cnt;
   			uint32_t totalSize = 0;

            /* For manual ETB drain buffer read mode, set the buffer ending
             *  address to know when the buffer has wrapped back to the
             *  beginning.
             */
            uint32_t endAddress = pct_edma_res.dbufAddress + (pct_edma_res.dbufWords*4) - 1;
            totalSize = pct_edma_res.availableWords;
            pBuffer = (uint32_t *)pct_edma_res.startAddr;

            sz = 0;
            for(cnt = 0; cnt < totalSize; cnt++)
            {
                etbword = *(pBuffer+sz);
                if(le[0] != 1) //Big endian
                   etbword = BYTE_SWAP32(etbword);

                fret = fwrite((void*) &etbword, 4, 1, fp);
                if ( fret < 1 ) {
                	printf("Error writing data to  - %s \n", core_fname[DNUM]);
                	exit (EXIT_FAILURE);
                }
                sz++;

                /* Check for wrap condition with circular buffer */
                if((uint32_t)(pBuffer+sz) > endAddress)
                {
                    pBuffer = (uint32_t *)pct_edma_res.dbufAddress;
                    sz = 0;
                }
            }

            printf("Successfully transported ETB data to %s, %d words\n",core_fname[DNUM], totalSize);

            fclose(fp);
#else
   			pBuffer = (uint32_t*) &etb_drain_mem;
			while(sz < size_out)
			{
				etbword = *(pBuffer+sz);
				if(le[0] != 1) //Big endian
				 	etbword = BYTE_SWAP32(etbword);

				fret = fwrite((void*) &etbword, 4, 1, fp);
                if ( fret < 1 ) {
                    printf("Error writing data to  - %s \n", core_fname[DNUM]);
                	exit (EXIT_FAILURE);
                }

				sz++;
			}
            fclose(fp);
			printf("Successfully transported ETB data to %s\n",core_fname[DNUM]);
#endif
		}
		else
		{
			printf("Error opening file - %s\n", core_fname[DNUM]);
			exit (EXIT_FAILURE);
		}
	}
}
